/*!
 * vue-wired v0.3.0
 * (c) 2017-present egoist <0x142857@gmail.com>
 * Released under the MIT License.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global.wired = factory());
}(this, (function () { 'use strict';

/**
 * Simply extracted from https://github.com/synacor/wiretie/blob/master/src/util.js
 */
function assign(obj) {
  var arguments$1 = arguments;

  for (var i = 1; i < arguments.length; i++) {
    // eslint-disable-next-line guard-for-in, prefer-rest-params
    for (var p in arguments[i]) { obj[p] = arguments$1[i][p]; }
  }
  return obj
}

// eslint-disable-next-line no-unused-vars
var index = function (models) {
  return function (Child) {
    if ( Child === void 0 ) Child = {};

    var modelNames = Object.keys(models);
    var extraProps = ['pending', 'rejected'];

    var props;
    if (Array.isArray(Child.props)) {
      props = Child.props.concat( modelNames, extraProps);
    } else if (typeof Child.props === 'object') {
      props = assign({}, arrToObj(modelNames.concat(extraProps)),
        Child.props);
    } else {
      props = modelNames.concat(extraProps);
    }

    return {
      name: Child.name ? ("wired-" + (Child.name)) : 'wired',
      props: Child.props,
      data: function data() {
        return {
          wiredState: assign({}, {pending: {},
            rejected: {}},
            arrToObj(modelNames))
        }
      },
      created: function created() {
        var this$1 = this;

        var loop = function () {
          var modelName = list[i];

          this$1.$set(this$1.wiredState.pending, modelName, true);
          var model = models[modelName];
          if (typeof model === 'function') {
            model = model.call(this$1, this$1);
          }
          model &&
            model
              .then(function (value) {
                this$1.$set(this$1.wiredState, modelName, value);
                this$1.$set(this$1.wiredState.pending, modelName, false);
              })
              .catch(function (err) {
                this$1.$set(this$1.wiredState.rejected, modelName, err);
                this$1.$set(this$1.wiredState.pending, modelName, false);
              });
        };

        for (var i = 0, list = modelNames; i < list.length; i += 1) loop();
      },
      render: function render(h) {
        var childProps = assign({}, this.$props, this.wiredState);

        return h(assign({}, Child, {props: props}), { props: childProps })
      }
    }
  }
};

function arrToObj(arr, val) {
  if ( val === void 0 ) val = null;

  return arr.reduce(function (res, key) {
    res[key] = val;
    return res
  }, {})
}

return index;

})));
